diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/src/sis2iby.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/src/sis2iby.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/src/sis2iby.cpp	2010-05-18 19:32:31.896848966 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/src/sis2iby.cpp	2010-05-15 17:08:28.000000000 +0100
@@ -18,6 +18,7 @@
 
 #include "sisutils.h"
 #include "sis2iby.h"
+#include <cstdlib>
 
 /**
 Constructor: Sis2Iby class
@@ -28,7 +29,7 @@
 
 @param aFile	- SIS file name
 */
-Sis2Iby::Sis2Iby(char* aFile) : SisUtils(aFile)
+Sis2Iby::Sis2Iby(char const* aFile) : SisUtils(aFile)
 {
 }
 
@@ -70,7 +71,7 @@
 
 	if(IsVerboseMode())
 	{
-		std::cout << "Processing " << (char*)sisFile.data() << std::endl;
+		std::cout << "Processing " << sisFile.c_str() << std::endl;
 	}
 
 	if(IsFileExist(sisFile))
@@ -86,12 +87,12 @@
 			break;
 		case STAT_FAILURE:
 			{
-				throw SisUtilsException((char*)sisFile.data(), "Failed to extract SIS file");
+				throw SisUtilsException(sisFile.c_str(),"Failed to extract SIS file");
 			}
 		}
 	}
 	else
-		throw SisUtilsException((char*)sisFile.data(), "File not found");
+		throw SisUtilsException(sisFile.c_str(),"File not found");
 }
 
 /**
@@ -128,18 +129,18 @@
 	ibyFile.append(".iby");
 
 	if( !MakeDirectory(iOutputPath) )
-		throw SisUtilsException((char*)iOutputPath.data(), "Failed to create path");
+		throw SisUtilsException(iOutputPath.c_str(),"Failed to create path");
 
 	if(IsVerboseMode())
 	{
-		std::cout << "Generating IBY file " << (char*)ibyFile.data() << std::endl;
+		std::cout << "Generating IBY file " << ibyFile.c_str() << std::endl;
 	}
 
 	ibyHandle.open((char*)ibyFile.data(),(std::ios::out));
 
 	if(!ibyHandle.good())
 	{
-		throw SisUtilsException((char*)ibyFile.data(), "Failed to create IBY file");
+		throw SisUtilsException(ibyFile.c_str(),"Failed to create IBY file");
 	}
 
 	// Generating Header
@@ -239,10 +240,10 @@
 			}
 		}
 		else
-			throw SisUtilsException((char*)pkgFileName.data(), "Could not create parser object");
+			throw SisUtilsException(pkgFileName.c_str(),"Could not create parser object");
 	}
 	else
-		throw SisUtilsException((char*)pkgFileName.data(), "File not found");
+		throw SisUtilsException(pkgFileName.c_str(),"File not found");
 }
 
 /**
@@ -551,7 +552,12 @@
 		aFile.assign(fPath);
 	}
 #else
-#error "TODO: Implement this function under other OS than Windows"
+	char fPath[FILENAME_MAX];
+	if (realpath(aFile.c_str(),fPath))
+	{
+		aFile.assign(fPath);
+	}
+
 #endif
 	return;
 }
@@ -652,7 +658,7 @@
 
 	if( !aIfs.is_open() )
 	{
-		throw SisUtilsException((char*)aFile.data(), "Cannot open file");
+		throw SisUtilsException(aFile.c_str(),"Cannot open file");
 	}
 
 	aIfs.seekg(0,std::ios::end);
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/src/sisutils.cpp /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/src/sisutils.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/imgtools/sisutils/src/sisutils.cpp	2010-05-18 19:32:31.896848966 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/imgtools/sisutils/src/sisutils.cpp	2010-05-15 17:05:31.000000000 +0100
@@ -20,6 +20,13 @@
 #include <windows.h>
 #include <direct.h>
 #endif
+#ifdef __LINUX__
+#include <vector>
+#include <cerrno>
+#include <sys/wait.h>
+#include <sys/stat.h>
+#endif
+
 
 #include "sisutils.h"
 
@@ -33,7 +40,7 @@
 @param aFile	- Name of the file
 @param aErrMessage - Error message
 */
-SisUtilsException::SisUtilsException(char* aFile, char* aErrMessage) : \
+SisUtilsException::SisUtilsException(char const* aFile, char const* aErrMessage) : \
 	iSisFileName(aFile), iErrMessage(aErrMessage)
 {
 }
@@ -72,7 +79,7 @@
 
 @param aFile	- Name of the SIS file
 */
-SisUtils::SisUtils(char* aFile) :  iVerboseMode(EFalse),iSisFile(aFile)
+SisUtils::SisUtils(char const* aFile) :  iVerboseMode(EFalse),iSisFile(aFile)
 {
 }
 
@@ -201,9 +208,47 @@
 	::CloseHandle( pi.hProcess );
 	::CloseHandle( pi.hThread );
 #else
-#error "TODO: Implement this function under other OS than Windows"
+	String::iterator pch = cmd.begin();
+	String::iterator end = cmd.end();
+	char *token = NULL;
+	std::vector<char *> args;
+	for ( ;pch != end; ++pch)
+	{
+		if (isspace(*pch))
+		{
+			*pch = '\0';
+			if (token) {
+				token = NULL;
+			}
+		}
+		else if (!token)
+		{
+			token = &*pch;
+			args.push_back(token);
+		}  
+	}
+	args.push_back((char *)NULL);
+    pid_t pid = fork();
+    if (pid == 0)
+	{
+        execv(args[0],&args[0]);
+    }
+    else if (pid < 0)
+	{
+        iExitCode = static_cast<TUint32>(STAT_FAILURE);
+    }
+    else
+	{
+		int rtc;
+        pid_t ws = waitpid( pid, &rtc, 0);
+        if (ws != pid) {
+            iExitCode = static_cast<TUint32>(STAT_FAILURE);
+        }
+		else {
+			iExitCode = rtc;
+		}
+    }
 #endif
-
 	return iExitCode;
 }
 
@@ -281,7 +326,13 @@
 			}
 		}
 #else
-#error "TODO: Implement this function under other OS than Windows"
+		if(mkdir(dir.data(),777) != 0)
+		{
+			if(errno != EEXIST)
+			{
+				status = EFalse;
+			}
+		}
 #endif
 		if(status == EFalse)
 			break;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/sbsv2/cpp-raptor/group/exports.inf /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/cpp-raptor/group/exports.inf
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/sbsv2/cpp-raptor/group/exports.inf	2010-05-18 19:32:31.900848497 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/cpp-raptor/group/exports.inf	2010-05-17 19:43:29.133345451 +0100
@@ -15,6 +15,6 @@
 *
 */
 
-../win32/bin/cpp.exe /tools/sbs/win32/bv/bin/cpp.exe
-../win32/i686-pc-mingw32/bin/cc1.exe /tools/sbs/win32/bv/i686-pc-mingw32/bin/cc1.exe
-../win32/i686-pc-mingw32/bin/libiconv-2.dll /tools/sbs/win32/bv/i686-pc-mingw32/bin/libiconv-2.dll
+../win32/bin/cpp.exe ../../tools/sbs/win32/bv/bin/cpp.exe
+../win32/i686-pc-mingw32/bin/cc1.exe ../../tools/sbs/win32/bv/i686-pc-mingw32/bin/cc1.exe
+../win32/i686-pc-mingw32/bin/libiconv-2.dll ../../tools/sbs/win32/bv/i686-pc-mingw32/bin/libiconv-2.dll
Only in /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin: recipestats.py
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/sbsv2/raptor/bin/sbs /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin/sbs
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/sbsv2/raptor/bin/sbs	2010-05-18 19:32:34.709348670 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin/sbs	2010-05-17 18:47:53.024843000 +0100
@@ -1,5 +1,5 @@
 #!/bin/bash
-# Copyright (c) 2007-2009 Nokia Corporation and/or its subsidiary(-ies).
+# Copyright (c) 2007-2010 Nokia Corporation and/or its subsidiary(-ies).
 # All rights reserved.
 # This component and the accompanying materials are made available
 # under the terms of the License "Eclipse Public License v1.0"
@@ -17,7 +17,7 @@
 #
 
 # If SBS_HOME is not set in the environment then work it out
-# from the path to this batch file
+# from the path to this script
 if [ -z "$SBS_HOME" ] ; then
 	temp=$0
 	SBS_HOME=$(cd ${temp%/*} && echo $PWD)
@@ -62,31 +62,47 @@
 fi
 
 if [ "$OSTYPE" == "cygwin" ]; then
-
-	SBS_HOME=${SBS_HOME//\\//}
-
 	__MINGW__=${SBS_MINGW:-$SBS_HOME/$HOSTPLATFORM_DIR/mingw}
 	__CYGWIN__=${SBS_CYGWIN:-$SBS_HOME/$HOSTPLATFORM_DIR/cygwin}
-	__PYTHON__=${SBS_PYTHON:-$SBS_HOME/$HOSTPLATFORM_DIR/python252/python.exe}
 
     # Command for unifying path strings. For example, "c:\some\path" and
     # "/cygdrive/c/some/path" will both be converted into "c:/some/path".
 	u="$__CYGWIN__/bin/cygpath.exe -m"
 
-	__MINGW__=$($u "$__MINGW__")
-	__CYGWIN__=$($u "$__MINGW__")
-	__PYTHON__=$($u "$__PYTHON__")
-
+	SBS_HOME=${SBS_HOME//\\//}
 	export SBS_HOME=$($u "$SBS_HOME")
-	export EPOCROOT=$($u "$EPOCROOT")
 
+	__MINGW__=$($u "$__MINGW__")
+	__CYGWIN__=$($u "$__MINGW__")
 	export PATH=${__MINGW__}/bin:${__CYGWIN__}/bin:$SBS_HOME/$HOSTPLATFORM_DIR/bin:$PATH
 
 	# Tell Cygwin not to map unix security attributes to windows to
 	# prevent raptor from potentially creating read-only files:
 	export CYGWIN='nontsec nosmbntsec'
 
+	# The python and PYTHONPATH used by Raptor are determined by, in order of precedence:
+	#  1. the SBS_PYTHON and SBS_PYTHONPATH environment variables (if set)
+	#  2. the python shipped locally with Raptor (if present)
+	#  3. the python on the system PATH and the PYTHONPATH set in the system environment
+
+	__LOCAL_PYTHON__=$SBS_HOME/win32/python264/python.exe
+
+	if [ -n "$SBS_PYTHON" ]; then
+		__PYTHON__=$SBS_PYTHON
+	elif [ -f "$__LOCAL_PYTHON__" ]; then
+		__PYTHON__=$__LOCAL_PYTHON__
+		export SBS_PYTHON=$__PYTHON__
+		export PYTHONPATH=
+	else
+		__PYTHON__=python.exe
+	fi
+	__PYTHON__=$($u "$__PYTHON__")		
+
+	if [ -n "$SBS_PYTHONPATH" ]; then
+		export PYTHONPATH=$($u "$SBS_PYTHONPATH")
+	fi
 else
+	export PYTHONPATH=${SBS_PYTHONPATH:-$SBS_HOME/$HOSTPLATFORM_DIR/python262/lib}
 	PATH=$SBS_HOME/$HOSTPLATFORM_DIR/python262/bin:$SBS_HOME/$HOSTPLATFORM_DIR/bin:$PATH
 	LD_LIBRARY_PATH=$SBS_HOME/$HOSTPLATFORM_DIR/python262/lib:$SBS_HOME/$HOSTPLATFORM_DIR/bv/lib:$LD_LIBRARY_PATH
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/sbsv2/raptor/bin/sbs.bat /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin/sbs.bat
--- /home/imk/symbian/epocroot-pdk-3.0.i/latest_build/build/sbsv2/raptor/bin/sbs.bat	2010-05-18 19:32:34.709348670 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin/sbs.bat	2010-05-17 18:47:53.024843000 +0100
@@ -1,5 +1,5 @@
 @rem
-@rem Copyright (c) 2005-2009 Nokia Corporation and/or its subsidiary(-ies).
+@rem Copyright (c) 2005-2010 Nokia Corporation and/or its subsidiary(-ies).
 @rem All rights reserved.
 @rem This component and the accompanying materials are made available
 @rem under the terms of the License "Eclipse Public License v1.0"
@@ -15,43 +15,7 @@
 @rem
 
 @SETLOCAL
-@SET HOSTPLATFORM=win 32
-@SET HOSTPLATFORM_DIR=win32
-
-
-@REM Automatically find SBS_HOME if it is not set
-@IF NOT "%SBS_HOME%"==""  goto foundhome
-@SET RAPTORBINDIR=%~dp0
-@SET WD=%cd%
-@cd %RAPTORBINDIR%\..
-@SET SBS_HOME=%cd%
-@cd %WD%
-:foundhome 
-
-@REM Use the python set by the environment if possible
-@SET __PYTHON__=%SBS_PYTHON%
-@IF "%__PYTHON__%"=="" SET __PYTHON__=%SBS_HOME%\win32\python252\python.exe
-
-@REM Use the mingw set by the environment if possible
-@SET __MINGW__=%SBS_MINGW%
-@IF "%__MINGW__%"=="" SET __MINGW__=%SBS_HOME%\win32\mingw
-
-@REM Use the cygwin set by the environment if possible
-@SET __CYGWIN__=%SBS_CYGWIN%
-@IF "%__CYGWIN__%"=="" SET __CYGWIN__=%SBS_HOME%\win32\cygwin
-
-@REM add to the search path
-@SET PATH=%__MINGW__%\bin;%__CYGWIN__%\bin;%SBS_HOME%\win32\bin;%PATH%
-
-@REM Make sure that /tmp is not set incorrectly for sbs
-@umount -u /tmp >NUL  2>NUL
-@mount -u %TEMP% /tmp >NUL 2>NUL
-@umount -u / >NUL  2>NUL
-@mount -u %__CYGWIN__% / >NUL 2>NUL
-
-@REM Tell CYGWIN not to map unix security attributes to windows to
-@REM prevent raptor from potentially creating read-only files:
-@set CYGWIN=nontsec nosmbntsec
+@CALL "%~dp0sbs_env.bat"
 
 @REM Run Raptor with all the arguments.
 @%__PYTHON__% %SBS_HOME%\python\raptor_start.py %*
Only in /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin: sbs_check_exports.py
Only in /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin: sbs_env.bat
Only in /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin: sbs_filter
Only in /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin: sbs_filter.bat
Only in /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin: sbs_filter.py
Only in /home/imk/symbian/epocroot-pdk-3.0.i/linux_build/sbsv2/raptor/bin: timelines.py
